/*
    Criado por:
        Alex Crispim - UNA-SUS/BSB
	Colaboradora:
        Nayara Rossi - UNA-SUS/BSB
    Criador de componentes Web 2021
    Versão: 2.15.0
*/

/*Função que possui todos os componentes que são montados nas páginas conforme se navega na aplicação. Recebe como parâmetro 1º o json com os itens de montagem da página, 2º a página que será montada e 3º o objeto que será montado na interface no momento, conforme conteudoCurso.json*/
function criarComponente(json, pagina, x) {
	let menuPagina, carregarPagina, carregar, contPrincipal;
	if(pagina !== "modal"){
		if(pagina.split("&")[0].startsWith("u")){
			let unidade = pagina.split("&")[0];
			menuPagina = pagina.split("&")[1];
			carregarPagina = pagina.split("&")[2];
			contPrincipal = json.conteudoPrincipal[unidade];
		} else {
			menuPagina = pagina.split("&")[0];
			carregarPagina = pagina.split("&")[1];
			contPrincipal = json.conteudoPrincipal;
		}
		carregar = contPrincipal[menuPagina][carregarPagina];
	} else {
		carregar = json;
	}
	return {
		arquivo: function (tag, cpnt) {
			let local, id, objeto;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			let endereco = objeto.endereco;
			let tipo = endereco.substring(endereco.lastIndexOf(".") + 1).toUpperCase();
			let nomeArquivo = endereco.substring(endereco.lastIndexOf("/") + 1);
			$(local).append(
				`<div data-componente="${id}" class="mt-md">
					<div class="leituras">
						<div class="grid-flex">
							<i class="uil uil-file-bookmark-alt"></i>
							<div>
								<span>Leitura Recomendada</span>
								<p>
									<a class="downloadArquivo" href="${objeto.endereco}" download="${nomeArquivo}"><strong>${objeto.texto}</strong></a> &boxh; ${tipo} &boxh; ${objeto.tamanho}
								</p>
							</div>
						</div>
					</div>
				</div>`
			);
		},
		link: function (tag, cpnt) {
			let local, id, objeto;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			let localMenu = $("#tituloPagina").attr("data-local");
			$(local).append(
				`<div data-componente="${id}" class="mt-md">
					<div class="leituras">
						<div class="grid-flex">
							<i class="uil uil-file-exclamation-alt"></i>
							<div>
								<span>Leitura Complementar</span>
								<p>
									<a class="leituraComplementar" data-toggle="modal" data-target="#modalDinamica" title="Clique para mostrar as leituras complementares deste curso" data-conteudo="leituraComplementar" data-item="${localMenu}"><strong>${objeto.texto}</strong></a>
								</p>
							</div>
						</div>
					</div>
				</div>`
			);
		},
		titulo: function (tag, cpnt, content) {
			let local, id, objeto, idComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(`<h${objeto.nivel} data-componente="${id}" id="${idComponente}" class="mb-md">${objeto.texto}</h${objeto.nivel}>`);
		},
		subtitulo: function (tag, cpnt, content) {
			let local, id, objeto, montaComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				montaComponente = `<div data-componente="${id}" class="mt-md"><h5>${objeto}</h5></div>`;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				montaComponente = `<h5 data-componente="${id}">${objeto}</h5>`;
			}
			$(local).append(montaComponente);
		},
		texto: function (tag, cpnt, content) {
			let local, id, objeto, idComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(`<p data-componente="${id}" id="${idComponente}" class="mb-md">${objeto}</p>`);
		},
		imagem: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, tmnItem, y, number = 0;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			Object.keys(objeto).filter(fig => {
				if(fig.startsWith("figura")) {
					number++;
				}
			});
			switch (number) {
				case 1:
					tmnItem = 12;
					break;
				case 2:
					tmnItem = 6;
					break;
				case 3:
					tmnItem = 4;
					break;
				default:
					tmnItem = 12;
					break;
			}
			$(local).append(`<div data-componente="${id}" id="${idComponente}" class="row mt-lg mb-lg${objeto.classe ? " " + objeto.classe : ""}"></div>`);
			for (y in objeto) {
				if(y.startsWith("figura")){
					$("#"+ idComponente).append(
						`<div class="col-xs-${tmnItem} col-sm-${objeto[y].tamanho || 10}${number == 1 ? " col-center" : ""}">
							<figure class="figure figure-card text-center">
								${objeto[y].titulo !== undefined ? `<h4 class="text-${objeto[y].alinhamentoTexto !== undefined ? objeto[y].alinhamentoTexto : "left"}">${objeto[y].titulo}</h4>` : ""}
								${objeto[y].legendaEmCimaImagem !== undefined ? `<div class="figure-reference">
									<img class="figure-img img-fluid rounded" src="${objeto[y].endereco}" alt="${objeto[y].alt}"/>
									<div class="text-${objeto[y].alinhamentoTexto !== undefined ? objeto[y].alinhamentoTexto : "left"}">
										<p>${objeto[y].legendaEmCimaImagem}</p>
									</div>
								</div>` :
								`<img class="figure-img img-fluid rounded" src="${objeto[y].endereco}" alt="${objeto[y].alt}"/>`}
								<figcaption class="figure-caption text-${objeto[y].alinhamentoTexto !== undefined ? objeto[y].alinhamentoTexto : "left"}">
									${objeto[y].legenda !== undefined ? `<p class="fontsize-sm">${objeto[y].legenda}</p>` : ""}
									${objeto[y].link !== undefined ? `<a class="btn btn-default btn-download${" " + objeto[y].link.tipo}" href="${objeto[y].link.endereco}" title="${objeto[y].link.title}" download="${objeto[y].link.endereco.substring(objeto[y].link.endereco.lastIndexOf("/") + 1)}"><i class="uil uil-image-download"></i> ${objeto[y].link.tipo === "linkExterno" ? "Visitar" : "Baixar"}</a>` : ""}
								</figcaption>
							</figure>
						</div>`
					);
				}
			}
		},
		imagemTexto: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, estruturaNormal, estruturaInvertida, y, naoComponentes, nomeComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			//Se existir o parâmetro mudarPosicao no json ele inverte a montagem do componente
			estruturaNormal = `<div class="col-sm-4 mb-lg text-center">
				<div><img class="img-responsive center-block" src="${objeto.imagemLado.endereco}" alt="${objeto.imagemLado.alt}" /></div>
				${objeto.imagemLado.legenda !== undefined ? `<div class="text-left"><small>${objeto.imagemLado.legenda}</small></div>` : ""}
			</div>
			<div class="col-sm-8 imgTextoConteudo"></div>`;
			estruturaInvertida = `<div class="col-sm-8 imgTextoConteudo"></div>
			<div class="col-sm-4 mb-lg text-center">
				<div><img class="img-responsive center-block" src="${objeto.imagemLado.endereco}" alt="${objeto.imagemLado.alt}" /></div>
				${objeto.imagemLado.legenda !== undefined ? `<div class="text-left"><small>${objeto.imagemLado.legenda}</small></div>` : ""}
			</div>`;
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="row mt-md${objeto.classe ? " " + objeto.classe : ""}">
					${objeto.mudarPosicao == undefined ? estruturaNormal : estruturaInvertida }
				</div>`
			);
			naoComponentes = ["imagemLado", "classe", "mudarPosicao"];
			for (y in objeto) {
				if(naoComponentes.includes(y)){
					continue;
				}
				nomeComponente = y.split(/[0-9]/)[0];//Regex para excluir números
				if (nomeComponente && this[nomeComponente] instanceof Function) {
					this[nomeComponente]("#"+ idComponente + " .imgTextoConteudo", y, objeto[y]);
				} else {
					console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
				}
			}
		},
		personagemBloco: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, nomeComponente, naoComponentes;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="bubble-chat-one mt-lg${objeto.classe ? " " + objeto.classe : ""}">
					<div class="row">
						<div class="col-xs-12 col-sm-3 text-center">
							<img class="img-circle shadown-md img-responsive center-block mb-md" src="${objeto.personagem.imagem.endereco}" alt="${objeto.personagem.imagem.alt}"/>
							${objeto.personagem.imagem.legenda ? `<p class="fontsize-sm">${objeto.personagem.imagem.legenda}</p>`: ""}
						</div>
						<div class="col-xs-12 col-sm-9">
							${objeto.personagem.titulo !== undefined ? `<h6>${objeto.personagem.titulo}</h6>` : ""}
							<ul class="list-chat-item left">
								<li class="chat-item"></li>
							</ul>
						</div>
					</div>
				</div>`
			);
			naoComponentes = ["personagem", "classe"];
			for (y in objeto) {
				if(naoComponentes.includes(y)){
					continue;
				}
				nomeComponente = y.split(/[0-9]/)[0];//Regex para excluir números
				if (nomeComponente && this[nomeComponente] instanceof Function) {
					this[nomeComponente]("#"+ idComponente +" .col-sm-9 .chat-item", y, objeto[y]);
				} else {
					console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
				}
			}
		},
		destaqueTexto: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, nomeComponente;
			if(!cpnt){
				console.warn(`O componente "${x}" não pode ser adicionado diretamente na página. Somente dentro do componente de personagemBloco, atualize seu JSON.`);
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;

				$(local).append(`<div data-componente="${id}" id="${idComponente}" class="citacao mb-md${objeto.classe ? " " + objeto.classe : ""}"></div>`);
				for (y in objeto) {
					if(y === "classe"){
						continue;
					}
					nomeComponente = y.split(/[0-9]/)[0];//Regex para excluir números
					if (nomeComponente && this[nomeComponente] instanceof Function) {
						this[nomeComponente]("#"+ idComponente, y, objeto[y]);
					} else {
						console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
					}
				}
			}
		},
		accordion: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, w, nomeComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(`
				<div data-componente="${id}" class="row mt-md${objeto.classe ? " " + objeto.classe : ""}">
					<div class="col-lg-12">
						<div id="${idComponente}" class="panel-group collapse-theme-one"></div>
					</div>
				</div>`
			);
			for (y in objeto) {
				if(y.startsWith("num")){
					$("#" + idComponente).append(
						`<div class="panel panel-default">
							<div class="panel-heading">
								<h5 class="panel-title">
									<a class="accordion-toggle collapsed" data-toggle="collapse" data-parent="#${idComponente}"
									href="#${idComponente + y}">${objeto[y].tituloAccordion}</a>
								</h5>
							</div>
							<div id="${idComponente + y}" class="panel-collapse collapse">
								<div class="panel-body ${idComponente + y}"></div>
							</div>
						</div>`
					);
					for (w in objeto[y]) {
						if(w === "tituloAccordion"){
							continue;
						}
						nomeComponente = w.split(/[0-9]/)[0];//Regex para excluir números
						if (nomeComponente && this[nomeComponente] instanceof Function) {
							this[nomeComponente]("#" + idComponente + y + " ." + idComponente + y, w, objeto[y][w]);
						} else {
							console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
						}
					}
				}
			}
			//Ação para que vídeos e áudios sejam pausados ao se abrir e fechar os accordions
			$(document).on("click", ".accordion-toggle", function(){
				let video = $(".panel-group").find("video");
				let audio = $(".panel-group").find("audio");
				if(video.length) {
					let i, src;
					for (i = 0; i < video.length; i++) {
						src = document.getElementById(video[i].id);
						src.pause();
					}
				}
				if(audio.length) {
					let i, src;
					for (i = 0; i < audio.length; i++) {
						src = document.getElementById(audio[i].id);
						src.pause();
						$("#"+ audio[i].id).siblings(".controls").children(".controllerAudio").removeClass("pause").addClass("play");
					}
				}
			});
		},
		blocoConteudo: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, cor, nomeComponente, montarComponente, naoComponentes;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			switch (objeto.corBloco) {
				case "roxo":
					cor = "panel-purple";
					break;
				case "verde":
					cor = "panel-green";
					break;
				case "vermelho":
					cor = "panel-red";
					break;
				case "azul":
					cor = "panel-blue";
					break;
				default:
					cor = "";
					break;
			}
			if(objeto.icone !== undefined){
				cor += " panel-small";
			}
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="row mt-md mb-md${objeto.classe ? " " + objeto.classe : ""}">
					${objeto.imagemLado !== undefined ? `<div class="col-sm-4 mb-lg text-center">
						<div class="img-thumbnail">
							<div><img class="img-responsive center-block" src="${objeto.imagemLado.endereco}" alt="${objeto.imagemLado.alt}" /></div>
							${objeto.imagemLado.legenda !== undefined ? `<div class="text-left"><small>${objeto.imagemLado.legenda}</small></div>` : ""}
						</div>
					</div>` : ""}
					<div class="col-sm-${objeto.imagemLado !== undefined ? 8 : 12}">
						<div class="panel panel-default ${cor}">
							<div class="panel-body ${idComponente}">
								${objeto.comentario !== undefined ? `<h4>
									<i class="uil-comment-alt"></i> ${objeto.comentario}
								</h4>` : ""}
								${objeto.icone !== undefined ? `<div class="grid-flex">
									<div class="bloco-icone">
										<i class="uil ${objeto.icone == true ? "uil-exclamation-circle" : objeto.icone}"></i>
									</div>
									<div class="conteudoBloco ${idComponente}"></div>
								</div>` : ""}
							</div>
						</div>
					</div>
				</div>`
			);//O BlocoConteudo por ter muitas variações conforme explicado no seu snippet para VSCode, ele pode ser um bloco comum, com cores selecionadas, com icone, com imagem lateral e com título e ícone para comentário.
			if(!objeto.icone){
				montarComponente = `panel-body.${idComponente}`;
			} else {
				montarComponente = `conteudoBloco.${idComponente}`;
			}
			naoComponentes = ["comentario", "imagemLado", "corBloco", "classe", "icone"];
			for (y in objeto) {
				if(naoComponentes.includes(y)){
					continue;
				}
				nomeComponente = y.split(/[0-9]/)[0];//Regex para excluir números
				if (nomeComponente && this[nomeComponente] instanceof Function) {
					this[nomeComponente]("#"+ idComponente +" ."+ montarComponente, y, objeto[y]);
				} else {
					console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
				}
			}
		},
		radio: function (tag, cpnt) {
			let local, id, objeto, opcoes, qtdAlternativas, enunciadoTexto, y, w, i;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			//Váriáveis para criação das opções em formato randômico
			opcoes = [];
			qtdAlternativas = 0;
			$(local).append(
				`<div data-componente="${id}" id="questionario${id}" class="tipoQuestao bloco-atividade${objeto.classe ? " " + objeto.classe : ""}">
					<div class="row">
						<div class="col-md-12 enunciadoTexto">
							<div class="bloco-texto"></div>
						</div>
						${objeto.imagemLado !== undefined ? `<div class="col-md-4 mt-md mb-md text-center">
							<div class="img-thumbnail">
								<div><img class="img-responsive" src="${objeto.imagemLado.endereco}" alt="${objeto.imagemLado.alt}" /></div>
								${objeto.imagemLado.legenda !== undefined ? `<div class="text-left"><small>${objeto.imagemLado.legenda}</small></div>` : ""}
							</div>
						</div>` : ""}
						<div class="col-md-${objeto.imagemLado !== undefined ? 8 : 12} mt-md mb-md">
							<div class="panel panel-default">
								<div class="panel-body">
									<form id="${id}" data-questionario="${objeto.questionario}" data-questao="${objeto.questao}" class="custom-forms">
										<div class="bloco-atividade__perguntas"></div>
									</form>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			enunciadoTexto = `#questionario${id} .enunciadoTexto .bloco-texto`;
			for (y in objeto) {
				if(y === "enunciado"){
					for (w in objeto[y]) {
						if (w.startsWith("texto")) {
							this.texto(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaDesordenada")) {
							this.listaDesordenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaOrdenada")) {
							this.listaOrdenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("imagem")) {
							if(!$("#questionario"+ id +" .enunciadoImagem").length){
								$("#questionario"+ id +" .enunciadoTexto").after('<div class="col-md-12 mt-md enunciadoImagem"></div>');
							}
							this.imagem("#questionario"+ id +" .enunciadoImagem", w, objeto[y][w]);
							continue;
						}
					}
					continue;
				}
				//Laço que verifica se existem opções para serem montadas
				if (y.startsWith("opcao")) {
					//Código para criar o preencher o array opcoes com as opções de escolha
					qtdAlternativas += 1;
					opcoes.push([y, objeto[y]]);
					continue;
				}
			}
			//Verifica se as opções carregadas do json condizem com a quantidade dentro do array
			if (opcoes.length === qtdAlternativas) {
				//Código para randomizar as opções
				opcoes.sort(function () { return (Math.round(Math.random()) - 0.5); });
				//Laço que renderiza na tela as opções que foram randomizadas
				for (i = opcoes.length - 1; i >= 0; i--) {
					$("#"+ id +" .bloco-atividade__perguntas").append(
						`<div class="radio ${opcoes[i][0]}">
							<label>
								<input type="radio" name="optionsRadios" id="questionario${objeto.questionario + id + opcoes[i][0]}" value="${opcoes[i][1].id}"/>
								<span class="cr">
									<i class="cr-icon uil-check"></i>
								</span>
								${opcoes[i][1].texto}
							</label>
							<div class="feedback alert animated fadeInDown faster${opcoes[i][0] === objeto.correta ? " alert-success" : " alert-danger"}" style="display: none">
								${opcoes[i][0] === objeto.correta ? `<strong><i class="uil uil-file-check-alt"></i> Alternativa correta</strong>` : `<strong><i class="uil uil-file-block-alt"></i> Alternativa incorreta</strong>`}
								<p class="mt-md">${opcoes[i][1].feedback.texto}</p>
								${opcoes[i][1].feedback.referencia != undefined ? `<span>${opcoes[i][1].feedback.referencia}</span>` : ""}
							</div>
						</div>`
					);
				}
			}
		},
		checkbox: function (tag, cpnt) {
			let local, id, objeto, opcoes, qtdAlternativas, enunciadoTexto, naoComponentes, y, w, i;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			//Váriáveis para criação das opções em formato randômico
			opcoes = [];
			qtdAlternativas = 0;
			$(local).append(
				`<div data-componente="${id}" id="questionario${id}" class="tipoQuestao bloco-atividade${objeto.classe ? " " + objeto.classe : ""}">
					<div class="row">
						<div class="col-md-12 enunciadoTexto">
							<div class="bloco-texto"></div>
						</div>
						${objeto.imagemLado !== undefined ? `<div class="col-md-4 mt-md mb-md text-center">
							<div class="img-thumbnail">
								<div><img class="img-responsive" src="${objeto.imagemLado.endereco}" alt="${objeto.imagemLado.alt}" /></div>
								${objeto.imagemLado.legenda !== undefined ? `<div class="text-left"><small>${objeto.imagemLado.legenda}</small></div>` : ""}
							</div>
						</div>` : ""}
						<div class="col-md-${objeto.imagemLado !== undefined ? 8 : 12} mt-md mb-md">
							<div class="panel panel-default">
								<div class="panel-body">
									<form id="${id}" data-questionario="${objeto.questionario}" data-questao="${objeto.questao}" class="custom-forms">
										<div class="bloco-atividade__perguntas"></div>
										<div class="mt-lg">
											<div class="bloco-atividade__acoes atividadeCheckbox">
												<a class="btn btn-primary btn-lg enviar" href="#">Responder</a>
												<a class="btn btn-primary btn-lg tentarNovamente" href="#" style="display: none">Tentar novamente</a>
												<div class="alert animated fadeIn bloco-atividade__alerta-info mensagemGabarito"></div>
											</div>
										</div>
									</form>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			enunciadoTexto = `#questionario${id} .enunciadoTexto .bloco-texto`;
			naoComponentes = ["classe", "questionario", "questao", "correta"];
			for (y in objeto) {
				if(naoComponentes.includes(y)){
					continue;
				}
				if(y === "enunciado"){
					for (w in objeto[y]) {
						if (w.startsWith("texto")) {
							this.texto(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaDesordenada")) {
							this.listaDesordenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaOrdenada")) {
							this.listaOrdenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("imagem")) {
							if(!$("#questionario"+ id +" .enunciadoImagem").length){
								$("#questionario"+ id +" .enunciadoTexto").after('<div class="col-md-12 mt-md enunciadoImagem"></div>');
							}
							this.imagem("#questionario"+ id +" .enunciadoImagem", w, objeto[y][w]);
							continue;
						}
					}
					continue;
				}
				//Laço que verifica se existem opções para serem montadas
				if (y.startsWith("opcao")) {
					//Código para criar o preencher o array opcoes com as opções de escolha
					qtdAlternativas += 1;
					opcoes.push([y, objeto[y]]);
					continue;
				}
			}
			//Verifica se as opções carregadas do json condizem com a quantidade dentro do array
			if (opcoes.length === qtdAlternativas) {
				//Código para randomizar as opções
				opcoes.sort(function () { return (Math.round(Math.random()) - 0.5); });
				//Laço que renderiza na tela as opções que foram randomizadas
				for (i = opcoes.length - 1; i >= 0; i--) {
					$("#"+ id +" .bloco-atividade__perguntas").append(
						`<div class="checkbox ${opcoes[i][0]}">
							<label>
								<input type="checkbox" data-item="${opcoes[i][0]}" name="optionsCheckbox" id="questionario${objeto.questionario + id + opcoes[i][0]}" value="${opcoes[i][1].id}">
								<span class="cr">
                                	<i class="cr-icon uil-check"></i>
                              	</span>
							  	${opcoes[i][1].texto}
							</label>
							<div class="feedback alert animated fadeInDown faster${objeto.correta.includes(opcoes[i][0]) ? " alert-success" : " alert-danger"}" style="display: none">
								${objeto.correta.includes(opcoes[i][0]) ? `<strong><i class="uil uil-file-check-alt"></i> Alternativa correta</strong>` : `<strong><i class="uil uil-file-block-alt"></i> Alternativa incorreta</strong>`}
								<p class="mt-md">${opcoes[i][1].feedback.texto}</p>
								${opcoes[i][1].feedback.referencia != undefined ? `<span>${opcoes[i][1].feedback.referencia}</span>` : ""}
							</div>
						</div>`
					);
				}
			}
			//Verifica se o gabarito existe no JSON dessa questão
			if(objeto.correta == undefined){
				console.error(`Você não colocou a resposta para o gabarito do questionário ${objeto.questionario} questão ${objeto.questao}`);
			}
		},
		video: function (tag, cpnt, content) {
			let local, id, objeto;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
			}
			$(local).append('<div data-componente="' + id + '" class="mt-lg videoPagina"><div align="center" class="embed-responsive embed-responsive-16by9 videoContainer"><video id="'+ objeto.video +'" poster="' + objeto.capa + '" class="embed-responsive-item analisarVideo" controls=""><source src="assets/videos/' + objeto.video + '_' + configurarQualidadeVideo() + '.mp4" data-video="' + objeto.video + '" type="video/mp4"></video>'+
				'<div id="qualidade" class="resolucaoVideo">'+
					'<a href="#" title="Clique aqui para fechar essa configuração" class="fecharResolucao"><i class="ti ti-close"></i></a>'+
					'<h1 class="titulo">Resoluções</h1>'+
					'<a class="escolha" data-resolucao="360p" href="#" title="Altere a resolução do vídeo para 360p">360p</a>'+
					'<a class="escolha" data-resolucao="720p" href="#" title="Altere a resolução do vídeo para 720p">720p</a>'+
					'<div class="resolution"></div>'+
				'</div>'+
				'<div class="downloadVideo">'+
					'<a href="#" title="Clique aqui para fechar essa configuração" class="fecharResolucao"><i class="ti ti-close"></i></a>'+
					'<h1 class="titulo">Fazer Download em:</h1>'+
					'<a data-resolucao="360p" class="downloadArquivo" href="assets/videos/' + objeto.video + '_360p.mp4" download="' + objeto.video + '_360p"  title="Faça o download do vídeo na resolução 360p">360p</a>'+
					'<a data-resolucao="720p" class="downloadArquivo" href="assets/videos/' + objeto.video + '_720p.mp4" download="' + objeto.video + '_720p"  title="Faça o download do vídeo na resolução 720p">720p</a>'+
					'<div class="resolution"></div>'+
				'</div></div>'+
				'<div class="videoDownload"><a href="#" title="Clique para fazer download deste vídeo" ><i class="uil-import"></i></a></div><div class="videoInfor"><a href="#" title="Clique para trocar a resolução deste vídeo"><i class="uil-cog"></i></a></div></div>');
		},
		audio: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, tmnItem, montagem, qtdItensLinha, number = 1;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(`<div data-componente="${id}" id="${idComponente}"${objeto.classe ? ` class="${objeto.classe}"` : ""}></div>`);
			qtdItensLinha = parseInt(objeto.qtdPorLinha) || 1;
			switch (qtdItensLinha) {
				case 1:
					tmnItem = 12;
					break;
				case 2:
					tmnItem = 6;
					break;
				case 3:
					tmnItem = 4;
					break;
				default:
					tmnItem = 12;
					break;
			}
			for (y in objeto) {
				if(y.startsWith("item")){
					if($("#"+ idComponente +" .linhaAudio"+ number).children().length >= qtdItensLinha){
						number++;
					}
					if($("#"+ idComponente +" .linhaAudio"+ number).children().length > qtdItensLinha || $("[data-componente='"+ id +"']").children().length == 0 || $("#"+ idComponente +" .linhaAudio"+ number).children().length == 0){
						$("#"+ idComponente).append(`<div class="linhaAudio${number} row mt-lg"></div>`);
						montagem = `#${idComponente} .linhaAudio${number}`;
					}
					$(montagem).append(
						`<div class="${tmnItem == 12 ? `col-lg-12` : `col-sm-${tmnItem}`} mt-md">
							<div class="audioComponent podcast">
								<div class="row">
									${objeto[y].imagem ? `<div class="col-sm-3 text-center">
										<img src="${objeto[y].imagem.endereco}" alt="${objeto[y].imagem.alt}" class="img-adaptative" />
									</div>` : ""}
									<div class="col-sm-${objeto[y].imagem ? 9 : 12} mt-sm">
										<h4>${objeto[y].titulo}</h4>
										<div class="audioPlayerUnasus">
											<audio id="${id}_${y}" class="audio" preload="metadata">
												<source src="${objeto[y].audio}" type="audio/mpeg">
												Your browser does not support the audio element.
											</audio>
											<input type="range" class="timeline" max="100" value="0">
											<div class="controls">
												<button title="Clique para dar Play ou Pause neste áudio" class="controllerAudio play btn btn-link"><i class="uil uil-play"></i> <i class="uil uil-pause"></i><span class="sr-only">Tocar/Pausar o áudio</span></button>
												<div class="timer">
													<span class="current mr-sm">00:00</span>
													<span class="separator">/</span>
													<span class="duration ml-sm">00:00</span>
												</div>
												<div class="sound">
													<div class="volumeControl">
														<div class="displayVolume hide">
															<input type="range" class="volume" max="100" value="0">
															<div class="displaySound">100</div>
														</div>
														<button title="Clique para abrir um controlador de volume" class="btSound full">
															<i class="uil uil-volume-up"></i>
															<i class="uil uil-volume"></i>
															<i class="uil uil-volume-down"></i>
															<i class="uil uil-volume-off"></i>
															<i class="uil uil-volume-mute"></i>
														</button>
													</div>
												</div>
												${objeto[y].download ? `<div class="more">
													<a title="Clique para fazer download deste áudio" class="download downloadArquivo" href="${objeto[y].audio}" download><i class="uil uil-import"></i></a>
												</div>` : ""}
											</div>
										</div>
									</div>
								</div>
							</div>
						</div>`
					);
				}
			}
		},
		tabela: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="tabela-comparativa row mt-lg${objeto.classe ? " " + objeto.classe : ""}">
					<div class="col-lg-12">
						<div class="panel panel-default">
							${objeto.titulo ? `<div class="panel-heading">
								<h6>${objeto.titulo}</h6>
							</div>` : ""}
							<div class="panel-body">
								<table id="${idComponente}" class="${objeto.corTema ? "tabela-colorida" : "tabela-branca"}">
									${objeto.cabecalho ? `<thead id="${idComponente}_Head"><tr></tr></thead>` : ""}
									<tbody id="${idComponente}_Body"></tbody>
									${objeto.ultimaLinha ? `<tfoot id="${idComponente}_Footer"><tr></tr></tfoot>` : ""}
								</table>
							</div>
						</div>
					</div>
				</div>`
			);
			for (y in objeto) {
				if (y.startsWith("cabecalho")) {
					for (let z in objeto[y]) {
						if (z.startsWith("coluna")) {
							$('#' + idComponente + "_Head tr").append(
								`<th id="${idComponente +"_"+ y +"_"+ z}"${objeto[y][z].width ? ` width="${objeto[y][z].width}"` : ""}${objeto[y][z].colspan ? ` colspan="${objeto[y][z].colspan}"` : ""}>${objeto[y][z].nome}</th>`
							);
						}
					}
					continue;
				}
				if (y.startsWith("linha")) {
					$("#" + idComponente + "_Body").append(`<tr id="${idComponente}_${y}"></tr>`);
					for (let z in objeto[y]) {
						if (z.startsWith("coluna")) {
							$("#" + idComponente + "_" + y).append(
								`<td id="${idComponente +"_"+ y +"_"+ z}"${objeto[y][z].width ? ` width="${objeto[y][z].width}"` : ""}${objeto[y][z].rowspan ? ` rowspan="${objeto[y][z].colspan}"` : ""}${objeto[y][z].colspan ? ` colspan="${objeto[y][z].colspan}"` : ""}>${objeto[y][z].texto}</td>`
							);
						}
					}
					continue;
				}
				if (y.startsWith("ultimaLinha")) {
					for (let z in objeto[y]) {
						if (z.startsWith("coluna")) {
							$("#" + idComponente + "_Footer tr").append(
								`<td id="${idComponente +"_"+ y +"_"+ z}"${objeto[y][z].colspan ? ` colspan="${objeto[y][z].colspan}"` : ""}>${objeto[y][z].texto}</td>`
							);
						}
					}
					continue;
				}
			}
		},
		listaDesordenada: function(tag, cpnt, content){
			this.lista("ul", tag, cpnt, content);
		},
		listaOrdenada: function(tag, cpnt, content){
			this.lista("ol", tag, cpnt, content);
		},
		lista: function (tpLista, tag, cpnt, content) {
			let local, id, objeto, idComponente, listStyle, y;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			switch (objeto.marcador) {
				case false:
					listStyle = "none";
					break;
				case "check":
					listStyle = "none";
					break;
				default:
					listStyle = objeto.marcador;
					break;
			}
			$(local).append(`<${tpLista} data-componente="${id}" id="${idComponente}" class="mt-md${objeto.marcador === "check" ? " list-bulletcheck" : ""}${objeto.classe ? " " + objeto.classe : ""}"${objeto.marcador !== undefined ? ` style="list-style: ${listStyle};"` : ""}></${tpLista}>`);
			let count = 1;
			for (y in objeto) {//Nível 1
				if (y.startsWith("item")) {
					$("#"+ idComponente).append(`<li class="mt-md">${objeto[y]}</li>`);
					count++;
					continue;
				}
				if (y.startsWith("sublista")) {
					let sublistNivel2;
					if(objeto[y].marcador == false){
						sublistNivel2 = "none";
					} else {
						sublistNivel2 = objeto[y].marcador;
					}
					$("#"+ idComponente).append(`<li class="sublista" ${tpLista === "ol" ? `value="${count-1}"` : ""}><${tpLista} class="${id + y}"${(objeto[y].marcador !== undefined ? ` style="list-style: ${sublistNivel2};"` : "")}></${tpLista}></li>`);
					count++;
					let z;
					for (z in objeto[y]) {//Nível 2
						if (z.startsWith("item")) {
							$("#"+ idComponente +" ."+ id + y).append(`<li class="mt-md">${objeto[y][z]}</li>`);
							continue;
						}
						if (z.startsWith("sublista")) {
							let sublistNivel3;
							if(objeto[y][z].marcador == false){
								sublistNivel3 = "none";
							} else {
								sublistNivel3 = objeto[y][z].marcador;
							}
							$("#"+ idComponente + " ." + id + y).append(`<li class="sublista"><${tpLista} class="${id + y + z}"${(objeto[y][z].marcador !== undefined ? ` style="list-style: ${sublistNivel3};"` : "")}></${tpLista}></li>`);
							let w;
							for(w in objeto[y][z]){//Nível 3
								if (w.startsWith("item")) {
									$("#" + idComponente + " ." + id + y + z).append(`<li>${objeto[y][z][w]}</li>`);
								}
							}
						}
					}
				}
			}
		},
		atividadeCombo: function (tag, cpnt) {
			let local, id, objeto, opcoes, qtdAlternativas, enunciadoTexto, y, w, i, combo;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			//Váriáveis para criação das opções em formato randômico
			opcoes = [];
			qtdAlternativas = 0;
			$(local).append(
				`<div data-componente="${id}" id="questionario${id}" class="tipoQuestao bloco-atividade${objeto.classe ? " " + objeto.classe : ""}">
					<div class="row">
						<div class="col-md-12 enunciadoTexto">
							<div class="bloco-texto"></div>
						</div>
						<div class="col-md-12 mt-md">
							<div class="panel panel-default">
								<div class="panel-body">
									<form id="${id}" data-questionario="${objeto.questionario}" data-questao="${objeto.questao}" class="custom-forms">
										<div class="bloco-atividade__perguntas"></div>
										<div class="mt-lg">
											<div class="bloco-atividade__acoes atividadeCombo">
												<a class="btn btn-primary btn-lg enviar" href="#">Responder</a>
												<a class="btn btn-primary btn-lg tentarNovamente" href="#" style="display: none">Tentar novamente</a>
												<div class="alert animated fadeIn bloco-atividade__alerta-info mensagemGabarito"></div>
											</div>
										</div>
									</form>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			enunciadoTexto = `#questionario${id} .enunciadoTexto .bloco-texto`;
			for (y in objeto) {
				if(y === "enunciado"){
					for (w in objeto[y]) {
						if (w.startsWith("texto")) {
							this.texto(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaDesordenada")) {
							this.listaDesordenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaOrdenada")) {
							this.listaOrdenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("imagem")) {
							if(!$("#questionario"+ id +" .enunciadoImagem").length){
								$("#questionario"+ id +" .enunciadoTexto").after('<div class="col-md-12 mt-md enunciadoImagem"></div>');
							}
							this.imagem("#questionario"+ id +" .enunciadoImagem", w, objeto[y][w]);
							continue;
						}
					}
					continue;
				}
				//Laço que verifica se existem opções para serem montadas
				if (y.startsWith("opcao")) {
					//Código para criar o preencher o array opcoes com as opções de escolha
					qtdAlternativas += 1;
					opcoes.push([y, objeto[y]]);
					continue;
				}
			}
			//Verifica se as opções carregadas do json condizem com a quantidade dentro do array
			if (opcoes.length === qtdAlternativas) {
				//Código para randomizar as opções
				opcoes.sort(function () { return (Math.round(Math.random()) - 0.5); });
				combo = [];
				//Laço que renderiza na tela as opções que foram randomizadas
				for (i = opcoes.length - 1; i >= 0; i--) {
					$("#"+ id +" .bloco-atividade__perguntas").append(
						`<div class="item bloco-atividade__feedback" id="questionario${objeto.questionario + id + opcoes[i][0]}" data-item="${opcoes[i][0]}">
							<select data-resposta="${opcoes[i][1].correta}"></select>
							<label>${opcoes[i][1].texto}</label>
							<div class="feedback alert animated fadeInDown faster" style="display: none">
								<strong></strong>
								<p class="mt-md">${opcoes[i][1].feedback.texto}</p>
								${opcoes[i][1].feedback.referencia != undefined ? `<span>${opcoes[i][1].feedback.referencia}</span>` : ""}
							</div>
						</div>`
					);
					//Verifica a existência do parâmetro "combo" e renderiza os itens de escolha
					if(opcoes[i][1].combo !== undefined) {
						combo =  opcoes[i][1].combo;
						combo.map(item => {
							$("#questionario" + objeto.questionario + id + opcoes[i][0] +" > select").append(`<option value="${item}">${item}</option>`);
						});
					} else {
						console.error(`O componentMaker.js necessita do parâmetro "combo" com as opções para funcionar!!! Verifique o item: ${id} > ${opcoes[i][0]} em seu JSON.`);
					}
					//Verifica a existência do parâmetro "correta"
					if(!opcoes[i][1].correta || opcoes[i][1].correta === undefined){
						console.error(`O componentMaker.js necessita do parâmetro "correta" para funcionar!!! Verifique o item: ${id} > ${opcoes[i][0]} em seu JSON.`);
					}
				}
			}
			//Verifica se a escolha está de acordo com a resposta armazenada no JSON através do atributo data-resposta no select.
			$("#"+ id +" .item select").on("change", function(){
				let id = $(this).parent().attr("id");
				let option = $(this).val();
				let resposta = $("#" + id + " select").attr("data-resposta");
				$("#"+ id +" .feedback").removeClass("alert-success alert-danger");
				if(resposta === option){
					$("#"+ id +" .feedback").addClass("alert-success");
					$("#"+ id +" .feedback strong").html('<i class="uil uil-file-check-alt"></i> Alternativa correta');
				} else {
					$("#"+ id +" .feedback").addClass("alert-danger");
					$("#"+ id +" .feedback strong").html('<i class="uil uil-file-block-alt"></i> Alternativa incorreta');
				}
			});
		},
		atividadeTexto: function (tag, cpnt) {
			let local, id, objeto, enunciadoTexto, naoComponentes, y, w;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			$(local).append(
				`<div data-componente="${id}" id="questionario${id}" class="tipoQuestao bloco-atividade${objeto.classe ? " " + objeto.classe : ""}">
					<div class="row">
						<div class="col-md-12 enunciadoTexto">
							<div class="bloco-texto"></div>
						</div>
						<div class="col-md-12 mt-md">
							<div class="panel panel-default">
								<div class="panel-body">
									<form id="${id}" data-questionario="${objeto.questionario}" data-questao="${objeto.questao}" class="custom-forms">
										<div class="bloco-atividade__perguntas">
											<div class="dissertativa checked-info">
												<div>
													<label>
														Digite sua resposta:
														<span>Max. 250 caracteres (<i>0</i> usados)</span>
													</label>
													<textarea class="form-control" rows="5" placeholder="Digite sua resposta aqui" maxlength="250"></textarea>
													<div class="bloco-atividade__feedback bloco-atividade__feedback-info">
														<div class="feedback alert animated fadeInDown faster" style="display: none;">
															<strong><i class="uil uil-file-block-alt"></i> ${objeto.feedback.titulo}</strong>
															<p class="mt-md">${objeto.feedback.texto}</p>
															${objeto.feedback.referencia != undefined ? `<span>${objeto.feedback.referencia}</span>` : ""}
														</div>
													</div>
												</div>
											</div>
										</div>
										<div class="mt-lg">
											<div class="bloco-atividade__acoes atividadeTexto">
												<a class="btn btn-primary btn-lg enviar" href="#">Responder</a>
												<div class="alert animated fadeIn bloco-atividade__alerta-info mensagemGabarito"></div>
											</div>
										</div>
									</form>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			enunciadoTexto = `#questionario${id} .enunciadoTexto .bloco-texto`;
			naoComponentes = ["classe", "questionario", "questao"];
			for (y in objeto) {
				if(naoComponentes.includes(y)){
					continue;
				}
				if(y === "enunciado"){
					for (w in objeto[y]) {
						if (w.startsWith("texto")) {
							this.texto(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaDesordenada")) {
							this.listaDesordenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("listaOrdenada")) {
							this.listaOrdenada(enunciadoTexto, w, objeto[y][w]);
							continue;
						}
						if (w.startsWith("imagem")) {
							if(!$("#questionario"+ id +" .enunciadoImagem").length){
								$("#questionario"+ id +" .enunciadoTexto").after('<div class="col-md-12 mt-md enunciadoImagem"></div>');
							}
							this.imagem("#questionario"+ id +" .enunciadoImagem", w, objeto[y][w]);
							continue;
						}
					}
					continue;
				}
			}
		},
		atividadeImagemArea: function (tag, cpnt) {
			let local, id, objeto, naoComponentes, y, combo;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			$(local).append(
				`<div data-componente="${id}" id="questionario${id}" class="bloco-genograma${objeto.classe ? " " + objeto.classe : ""}">
					<div id="${id}" class="row md atividadeImagemArea">
						${objeto.tituloPadrao ? `<div class="col-md-12">
							<h2 class="mt-md mb-md">Respostas das áreas</h2>
						</div>` : ""}
				 	</div>
              </div>`
			);
			naoComponentes = ["classe", "questionario", "tituloPadrao"];
			for (y in objeto) {
				if(naoComponentes.includes(y)){
					continue;
				}
				if(y.startsWith("area")){
					$("#questionario"+ id +" .atividadeImagemArea").append(
						`<div class="col-md-12">
							<div class="panel panel-default progresso tipoQuestao">
								<div class="panel-body">
									<form id="${id}_questao${objeto[y].questao}" data-questionario="${objeto.questionario}" data-questao="${objeto[y].questao}" class="custom-forms">
										<div class="row">
											<div class="col-md-5">
												<figure class="figure figure-card figure-full">
													${objeto[y].idArea !== undefined ? `<span class="badge badge-big badge-orange">${objeto[y].idArea}</span>` : ""}
													<a data-toggle='modal' data-target='#modalDinamica' title='Clique para mostrar a imagem' data-conteudo='conteudoExtra' data-item='${objeto[y].imagem.link.id}'>
														<img class="figure-img img-responsive" src="${objeto[y].imagem.endereco}" alt="${objeto[y].imagem.alt}">
													</a>
													<figcaption class="figure-caption text-center">
													<a data-toggle='modal' data-target='#modalDinamica' title='Clique para mostrar a imagem' data-conteudo='conteudoExtra' data-item='${objeto[y].imagem.link.id}'><i class="uil uil-arrow-resize-diagonal"></i> Ampliar</a>
													</figcaption>
												</figure>
											</div>
											<div class="col-md-7 bloco-atividade__perguntas">
												<h3 class="mb-md"><i class="uil uil-comment-notes"></i> ${objeto[y].titulo}</h3>
												<p class="mb-md">${objeto[y].texto}</p>
												<div class="item bloco-atividade__feedback" id="questionario${objeto.questionario + id + y}" data-item="${y}">
													<select data-resposta="${objeto[y].correta}"></select>
													<div class="feedback alert animated fadeInDown faster" style="display: none">
														<strong></strong>
														<p class="mt-md">${objeto[y].feedback.texto}</p>
														${objeto[y].feedback.referencia != undefined ? `<span>${objeto[y].feedback.referencia}</span>` : ""}
													</div>
												</div>
											</div>
										</div>
									</form>
								</div>
							</div>
						</div>`
					);
					if(objeto[y].combo !== undefined) {
						combo =  objeto[y].combo;
						combo.map(item => {
							$("#questionario" + objeto.questionario + id + y +" > select").append(`<option value="${item}">${item}</option>`);
						});
					} else {
						console.error(`O componentMaker.js necessita do parâmetro "combo" com as opções para funcionar!!! Verifique o item: ${id} > ${y} em seu JSON.`);
					}
					//Verifica a existência do parâmetro "correta"
					if(!objeto[y].correta || objeto[y].correta === undefined){
						console.error(`O componentMaker.js necessita do parâmetro "correta" para funcionar!!! Verifique o item: ${id} > ${y} em seu JSON.`);
					}
					continue;
				}
			}
			//Verifica se a escolha está de acordo com a resposta armazenada no JSON através do atributo data-resposta no select.
			$("#" + id +" .item select").on("change", function(){
				let id = $(this).parent().attr("id");
				let option = $(this).val();
				let resposta = $("#" + id + " select").attr("data-resposta");
				$("#"+ id +" .feedback").removeClass("alert-success alert-danger");
				if(resposta === option){
					$("#"+ id +" .feedback").addClass("alert-success");
					$("#"+ id +" .feedback strong").html('<i class="uil uil-file-check-alt"></i> Alternativa correta');
				} else {
					$("#"+ id +" .feedback").addClass("alert-danger");
					$("#"+ id +" .feedback strong").html('<i class="uil uil-file-block-alt"></i> Alternativa incorreta');
				}
			});
		},
		escala: function (tag, cpnt, content) {
			let local, id, objeto, idComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="bloco-range${objeto.classe ? " "+objeto.classe : ""}">
					<div class="row mt-md">
						<div class="col-md-${objeto.tamanho || 12} col-center">
							<div class="reviews_message statisfied d-flex align-items-center">
								<div class="options">
									<div class="negative">
										<p>${objeto.esquerda.titulo}</p>
										<span>${objeto.esquerda.resposta}</span>
									</div>
									<div class="positive">
										<p>${objeto.direita.titulo}</p>
										<span>${objeto.direita.resposta}</span>
									</div>
								</div>
								<div class="range w-100">
									<span class="reviews-label icon-meh" style="left: 50%; transform: translateX(-50%);">Arraste para os lados</span>
									<div class="reviews-fill" style="left: auto; right: 50%; width: calc(0% - 4px);"></div>
									<input type="range" class="form-control-range reviews-range" min="0" max="100" step="1" value="50">
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
		},
		atividadeLikert: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, itens, valorItem, legendas;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}"  class="${objeto.classe ? " " + objeto.classe : ""}">
					<div class="bloco-atividade__escala atividadeLikert tipoQuestao">
						<form data-questionario="${objeto.questionario}" data-questao="${objeto.questao}">
							<div class="row mt-md itensEscala"></div>
							<div class="bloco-atividade__acoes">
								<a class="btn btn-primary btn-lg enviar" href="#">Enviar</a>
								<div class="alert alert-info animated fadeIn bloco-atividade__alerta-info mensagemGeral" style="display: none;"></div>
								<div class="alert alert-info animated fadeIn bloco-atividade__alerta-info mensagemFeedback" style="display: none;">
									<i class="uil uil-exclamation-circle"></i>
									<p>
										${objeto.feedback.texto}
										${objeto.feedback.referencia != undefined ? `<br><span>${objeto.feedback.referencia}</span>` : ""}
									</p>
								</div>
							</div>
						</form>
					</div>
				</div>`
			);
			for (y in objeto) {
				if(y.startsWith("pergunta")){
					itens = [];
					valorItem = [];
					legendas = [];
					$("#"+ idComponente +" .itensEscala").append(
						`<div class="col-md-12 col-center pergunta ${y}">
							<div class="panel panel-default">
								<div class="pane-heading bloco-atividade__escala-head">
									<h5>${objeto[y].enunciado}</h5>
								</div>
								<div class="pane-body">
									<div class="col=md-12 text-center">
										<div class="bloco-atividade__escala-body itensEscolha"></div>
									</div>
								</div>
								<div class="pane-footer">
									<div class="bloco-atividade__escala-legenda itensLegenda">
										<a href="#" class="btn-ajuda" title="Legenda sobre cada opção na atividade"><i class="uil uil-angle-right"></i> Ajuda (legenda)</a>
										<ul></ul>
									</div>
								</div>
							</div>
						</div>`
					);
					itens = objeto.itensEscala;
					valorItem = objeto[y].valorEscala;
					legendas = objeto.legenda;
					itens.forEach((item, i) => {
						$("#"+ idComponente +" ."+ y +" .itensEscolha").append(
							`<div class="item_escala">
								<input type="radio" name="${idComponente + y}" id="${idComponente + y +"item_"+ (i+1)}" value="${valorItem[i]}" />
								<label for="${idComponente + y +"item_"+ (i+1)}">${item}</label>
							</div>`
						);
					});
					legendas.forEach((legenda, i) => {
						$("#"+ idComponente +" ."+ y +" .itensLegenda ul").append(
							`<li>
								<span>${itens[i]}</span>
								<p>${legenda}</p>
							</li>`
						);
					});
				}
			}
			//Cria um atributo data-valor com o valor/peso escolhido pelo usuário
			$(".atividadeLikert input").on("click", function(){
				let valorEscolhido = $(this).val();
				$(this).parents(".pergunta").attr("data-valor", valorEscolhido);
			});
		},
		html: function (tag, cpnt, content) {
			let local, id, objeto, idComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			$(local).append(`<div data-componente="${id}" id="${idComponente}" class="mt-md mb-md${objeto.classe ? " "+objeto.classe : ""}">${objeto.conteudoHTML}</div>`);
		},
		timeline: function (tag, cpnt) {
			let local, id, objeto, y, count = 0;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			$(local).append(
				`<div data-componente="${id}" id=${id} class="timeline${objeto.classe ? " "+objeto.classe : ""}">
					<div class="row mt-lg">
						<div class="col-lg-12 linhaTempo">
							<div id="timelineAccordion" class="vtl">
								<div class="heading-vtl label label-default back-black-teal text-uppercase">Linha do tempo</div>
							</div>
						</div>
					</div>
				</div>`
			);
			let localItem = "#"+ id +" .linhaTempo .vtl";
			for (y in objeto) {
				if(y.startsWith("item")){
					let customIcon = "";
					switch (objeto[y].conteudo.icone) {
						case "video":
							customIcon = "uil-play-circle";
							break;
						default:
							customIcon = "";
							break;
					}
					$(localItem).append(
						`<div class="vtl-item">
							<div class="panel panel-default">
								<div class="panel-heading">
									<h5>
										<a data-toggle="collapse" class="accordion-toggle${count === 0 ? "" : " collapsed"}" href="#timelineAccordion_${y}"
										data-parent="#timelineAccordion">${objeto[y].tituloItem}
											<i class="uil uil-plus"></i>
											<i class="uil uil-minus"></i>
										</a>
									</h5>
								</div>
								<div id="timelineAccordion_${y}" class="panel-collapse collapse${count === 0 ? " in" : ""}">
									<div class="panel-body">
										${objeto[y].conteudo.titulo ? `${objeto[y].conteudo.icone !== undefined ? `<div class="col-xs-1 text-right">
											<i class="${customIcon} fontsize-lg"></i>
										</div>` : ""}
										<div class="col-xs-${objeto[y].conteudo.icone !== undefined ? 10 : 12}">
											<p class="text-dark-gray">
												<strong>${objeto[y].conteudo.modal ? `<a data-toggle="modal" data-target="#modalDinamica" title="Clique para mostrar o item ${objeto[y].conteudo.titulo}." data-conteudo="conteudoExtra" data-item="${objeto[y].conteudo.modal}">${objeto[y].conteudo.titulo}</a>` : objeto[y].conteudo.titulo}</strong>
											</p>
											<p>${objeto[y].conteudo.texto}</p>
											${objeto[y].conteudo.tempo ? `<p class="label label-primary label-outlined label-rounded">
												<i class="uil-clock"></i> ${objeto[y].conteudo.tempo}
											</p>` : ""}
										</div>` : `${objeto[y].conteudo.texto}`}
									</div>
								</div>
							</div>
						</div>`
					);
					count++;
				}
			}
		},
		destaque: function (tag, cpnt) {
			let local, id, objeto, y, tmnItem, number = 0;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			Object.keys(objeto).filter(item => {
				if(item.startsWith("item")) {
					number++;
				}
			});
			switch (number) {
				case 2:
					tmnItem = 6;
					break;
				case 3:
					tmnItem = 4;
					break;
				case 4:
					tmnItem = 3;
					break;
				default:
					tmnItem = 6;
					break;
			}
			$(local).append(`<div data-componente="${id}" id="${id}" class="row mt-lg${objeto.classe ? " " + objeto.classe : ""}"></div>`);
			for (y in objeto) {
				if(y.startsWith("item")){
					$("#"+ id).append(
						`<div class="col-md-${tmnItem}">
							<div class="panel panel-default panel-head-colored"">
								<div class="panel-heading text-white">
									<h6>${objeto[y].titulo}</h6>
								</div>
								<div class="panel-body">${objeto[y].texto}</div>
							</div>
						</div>`
					);
				}
			}
		},
		chat: function (tag, cpnt, content) {
			let local, id, objeto, idComponente, y, w, z, montarComponente, count = 0, automatico = false, tempoPadrao;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			//Verifica se o chat será dinâmico
			if(objeto.automatizado){
				automatico = true;
				tempoPadrao = objeto.automatizado.tempoPadrao || 3000;
			}
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="${automatico ? "bloco-atividade bloco-conversas" : "row mt-lg"}${objeto.classe ? " " + objeto.classe : ""}">
					${automatico ? `<div class="row mt-lg">
						<div class="col-md-12">
							<div class="bloco-titulo clearfix">
								<h6>${objeto.automatizado.tituloGeral || "Diálogo entre os personagens"}</h6>
								<a data-toggle="modal" data-target="#modalDinamica" title="Clique para mostrar a ajuda de como utilizar o componente" data-conteudo="conteudoExtra" data-item="chatDinamicoAjuda">Ajuda</a>
							</div>
						</div>
						${objeto.automatizado.enunciado ? `<div class="col-md-12">
							<div class="bloco-texto enunciado"></div>
						</div>` : ""}
						<div class="col-md-12 mt-md">
							<div class="panel panel-default">
								<div class="panel-body chat"></div>
							</div>
						</div>` : `<div class="col-lg-12 chat"></div>`}
						${automatico ? `<div class="col-md-12">
							<div class="bloco-atividade__footer clearfix">
								<div class="bloco-atividade__footer-controle col-sm-6 col-xs-12">
									<a class="btn btn-primary btn-lg btn-round btn-iniciar" href="#"><i class="uil uil-play-circle"></i> Iniciar</a>
									<a class="btn btn-default btn-lg btn-round btn-pausar" href="#"><i class="uil uil-pause-circle"></i> Pausar</a>
									<a class="btn btn-default btn-lg btn-round btn-retomar" href="#"><i class="uil uil-pause-circle"></i> Retomar</a>
									<a class="btn-recomecar" href="#">Recomeçar</a>
									<a class="btn btn-default btn-lg btn-round-lg btn-anterior disabled" href="#"><i class="uil uil-previous"></i></a>
									<a class="btn btn-default btn-lg btn-round-lg btn-proximo" href="#"><i class="uil uil-step-forward"></i></a>
								</div>
								<div class="col-sm-6 col-xs-12 text-right bloco-atividade__footer-acoes">
									<a href="#" class="btn-mostrarTodos">Mostrar diálogo todo</a>
									<p>(1 de 4)</p>
								</div>
							</div>
						</div>
					</div>` : ""}
				</div>`
			);
			for (y in objeto) {
				if(y.startsWith("conversa")){
					if(count%2 == 0){
						$("#"+ idComponente +" .chat").append(
							`<div class="bubble-chat-one${automatico ? " bloco-conversas__fala" : ""}"${automatico ? ` data-tempo="${objeto[y].tempoAutomatico || tempoPadrao}"` : ""}>
								<div class="row">
									<div class="col-sm-2 text-center">
										<img src="${objeto[y].imagem.endereco}" alt="${objeto[y].imagem.alt}" class="img-circle img-responsive shadown-md"/>
									</div>
									<div class="col-sm-8">
										${objeto[y].titulo ? `<h6>${objeto[y].titulo}</h6>` : ""}
										<ul class="list-chat-item left ${idComponente + y}"></ul>
									</div>
								</div>
							</div>`
						);
					} else {
						$("#"+ idComponente +" .chat").append(
							`<div class="bubble-chat-one inverso${automatico ? " bloco-conversas__fala" : ""}"${automatico ? ` data-tempo="${objeto[y].tempoAutomatico || tempoPadrao}"` : ""}>
								<div class="row">
									<div class="col-sm-8 col-sm-offset-2">
										${objeto[y].titulo ? `<h6 class="text-right">${objeto[y].titulo}</h6>` : ""}
										<ul class="list-chat-item right ${idComponente + y}"></ul>
									</div>
									<div class="col-sm-2 text-center">
										<img src="${objeto[y].imagem.endereco}" alt="${objeto[y].imagem.alt}" class="img-circle img-responsive shadown-md"/>
									</div>
								</div>
							</div>`
						);
					}
					for (w in objeto[y]) {
						if(w.startsWith("fala")){
							if(count%2 == 0){
								montarComponente = `#${idComponente} .${idComponente + y}`;
								$(montarComponente).append(`<li class="chat-item ${w}"></li>`);
							} else {
								montarComponente = `#${idComponente} .inverso .${idComponente + y}`;
								$(montarComponente).append(`<li class="chat-item ${w} back-blue-aqua-light"></li>`);
							}
							for (z in objeto[y][w]) {
								nomeComponente = z.split(/[0-9]/)[0];//Regex para excluir números
								if (nomeComponente && this[nomeComponente] instanceof Function) {
									this[nomeComponente](montarComponente +" ."+ w, y + w + z, objeto[y][w][z]);//O segundo parâmetro está com identificador maior por conta das conversas e falas.
								} else {
									console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
								}
							}
						}
					}
					count++;
					continue;
				}
				if(y.startsWith("separador")){
					$("#"+ idComponente +" .chat").append(
						`<div class="${y} bloco-conversas__texto${automatico ? " bloco-conversas__fala" : ""} clearfix" ${automatico ? `data-tempo="${objeto[y].tempoAutomatico || tempoPadrao}"` : ""}>
							<div class="col-md-12 conteudoSeparador"></div>
						</div>`
					);
					for (w in objeto[y]) {
						if(w !== "tempoAutomatico"){
							nomeComponente = w.split(/[0-9]/)[0];//Regex para excluir números
							if (nomeComponente && this[nomeComponente] instanceof Function) {
								this[nomeComponente](`#${idComponente} .chat .${y} .conteudoSeparador`, y + w, objeto[y][w]);
							} else {
								console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
							}
						}
					}
					continue;
				}
				if(y === "automatizado"){
					for (w in objeto[y]) {
						if(w === "enunciado"){
							for (z in objeto[y][w]) {
								nomeComponente = z.split(/[0-9]/)[0];//Regex para excluir números
								if (nomeComponente && this[nomeComponente] instanceof Function) {
									this[nomeComponente](`#${idComponente} .enunciado`, y + w + z, objeto[y][w][z]);
								} else {
									console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
								}
							}
						}
					}
				}
			}
		},
		tabs: function (tag, cpnt) {
			let local, id, objeto, y, w, z, nomeComponente, count = 0;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			$(local).append(
				`<div data-componente="${id}" id="${id}" class="row mt-lg${objeto.classe ? " " + objeto.classe : ""}">
					<div class="col-lg-12">
						<div class="panel panel-default">
							<div class="panel-heading">
								<h6>${objeto.titulo}</h6>
							</div>
							<div class="tabs-theme-one">
								<ul class="nav nav-tabs titulosTabs" role="tablist"></ul>
								<div class="panel-body">
    								<div class="tab-content"></div>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			for (y in objeto) {
				if(y.startsWith("tab")){
					$("#"+ id +" .titulosTabs").append(
						`<li role="presentation"${count == 0 ? ' class="active"' : ""}>
							<a href="#${id + y}" aria-controls="${id + y}" role="tab" data-toggle="tab">${objeto[y].nome}</a>
						</li>`
					);
					$("#"+ id +" .tab-content").append(`<div role="tabpanel" class="tab-pane${count == 0 ? " active" : ""}" id="${id + y}"></div>`);
					for (w in objeto[y]) {
						if(w === "nome"){
							continue;
						}
						if(w.startsWith("destaque")){
							$("#"+ id + y).append(
								`<div class="panel panel-default panel-head-colored destaque">
								${objeto[y][w].tituloDestaque ? `<div class="panel-heading panel-heading-sm text-white"><p><strong>${objeto[y][w].tituloDestaque}</strong></p></div>` : "" }
									<div class="panel-body"></div>
								</div>`
							);
							for (z in objeto[y][w]) {
								if(z === "tituloDestaque"){
									continue;
								}
								nomeComponente = z.split(/[0-9]/)[0];//Regex para excluir números
								if (nomeComponente && this[nomeComponente] instanceof Function) {
									this[nomeComponente]("#"+ id + y +" .destaque .panel-body", z + y, objeto[y][w][z]);//z + y identifica em qual tab e destaque será adicionado o componente
								} else {
									console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
								}
							}
							continue;
						} else {
							nomeComponente = w.split(/[0-9]/)[0];//Regex para excluir números
							if (nomeComponente && this[nomeComponente] instanceof Function) {
								this[nomeComponente]("#"+ id + y, w, objeto[y][w]);
							} else {
								console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
							}
						}
					}
					count++;
				}
			}
		},
		flip: function (tag, cpnt) {
			let local, id, objeto, y, tmnItem, montagem, qtdItensLinha, number = 1;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
			} else {
				local = tag;
				id = cpnt;
				objeto = carregar[x][cpnt];
			}
			$(local).append(`<div data-componente="${id}" id="${id}"${objeto.classe ? ` class="${objeto.classe}"` : ""}></div>`);
			qtdItensLinha = parseInt(objeto.qtdPorLinha) || 2;
			switch (qtdItensLinha) {
				case 2:
					tmnItem = 6;
					break;
				case 3:
					tmnItem = 4;
					break;
				case 4:
					tmnItem = 3;
					break;
				default:
					tmnItem = 6;
					break;
			}
			for (y in objeto) {
				if(y.startsWith("card")){
					if($("#"+ id +" .linhaCards"+ number).children().length >= qtdItensLinha){
						number++;
					}
					if($("#"+ id +" .linhaCards"+ number).children().length > qtdItensLinha || $("[data-componente='"+ id +"']").children().length == 0 || $("#"+ id +" .linhaCards"+ number).children().length == 0){
						$("#"+ id).append(`<div class="linhaCards${number} row mt-lg"></div>`);
						montagem = `#${id} .linhaCards${number}`;
					}
					$(montagem).append(
						`<div class="col-sm-${tmnItem}">
							<div class="flip flip-click">
								<div class="flip-front animated flipInY">
									<div class="panel panel-default border-left">
										<div class="panel-body">
											${objeto[y].frente.titulo !== undefined ? `<h6>${objeto[y].frente.titulo}</h6>` : ""}
											${objeto[y].frente.imagem !== undefined ? `<div class="row vertical-align flex-wrap margin-bottom-10">
												<div class="col-xs-12 col-sm-6 margin-bottom-10">
													<img alt="${objeto[y].frente.imagem.alt}" class="img-circle shadown-md img-responsive center-block" src="${objeto[y].frente.imagem.endereco}" />
												</div>
												${objeto[y].frente.imagem.legenda !== undefined ? `<div class="col-xs-12 col-sm-6">
													<small>${objeto[y].frente.imagem.legenda}</small>
												</div>` : ""}
											</div>` : ""}
											<a class="fontsize-xs"><i class="uil-sync"></i> Clique para virar o card</a>
										</div>
									</div>
								</div>
								<div class="flip-back animated flipInY">
									<div class="panel panel-default">
										<div class="panel-body">
											<p><strong>${objeto[y].verso.titulo}</strong></p>
											<p>${objeto[y].verso.texto}</p>
											<a class="fontsize-xs"><i class="uil-sync"></i> Voltar</a>
										</div>
									</div>
								</div>
							</div>
						</div>`
					);
				}
			}
			$(".flip").flip();
		},
		pdf: function (tag, cpnt, content) {
			let local, id, objeto, idComponente;
			if (!cpnt) {
				local = "#paginaConteudo";
				id = x;
				objeto = carregar[x];
				idComponente = id;
			} else {
				local = tag;
				id = cpnt;
				objeto = content;
				idComponente = local.split(' ')[0].replace("#", "") +"_"+ id;
			}
			let endereco = objeto.endereco;
			let nomeArquivo = endereco.substring(endereco.lastIndexOf("/") + 1);
			$(local).append(
				`<div data-componente="${id}" id="${idComponente}" class="mt-md mb-md${objeto.classe ? " "+objeto.classe : ""}">
					<div class="row">
						<div class="col-md-12 mt-md">
							<div class="downloadPDF"><a class="downloadArquivo" href="${endereco}" download="${nomeArquivo}"><i class="uil uil-file-download"></i> Download</a></div>
							<iframe class="pdf_viewer" src="assets/libs/js/pdfjs-dist/web/viewer.html?file=../../../../../${endereco}" style="width: 100%; height: 50vh; border: none;"></iframe>
						</div>
					</div>
				</div>`
			);
		},
		capa: function () {
			let objeto = carregar[x];
			let contObjetivo = json.modal.objetivos;
			let objetivoID = contPrincipal[menuPagina].objetivo;
			$("#paginaConteudo").append(
				`<div id="capaUnidade" class="row mt-md">
					${objeto.imagem !== undefined ? `<div class="col-sm-4 mb-lg text-center">
						<div class="img-thumbnail">
							<div><img class="img-responsive" src="${objeto.imagem.endereco}" alt="${objeto.imagem.alt}" /></div>
							${objeto.imagem.legenda !== undefined ? `<div class="text-left"><small>${objeto.imagem.legenda}</small></div>` : ""}
						</div>
					</div>` : ""}
					<div class="col-sm-${objeto.imagem !== undefined ? 8 : 12}">
						<div class="panel panel-default">
							<div class="panel-body objetivo">
								<h4 class="mb-md">
									<i class="uil-presentation-edit"></i> Objetivo(s) da aprendizagem
								</h4>
								<div class="mt-lg">
									<a class="btn btn-primary btn-lg carregarPagina" href="${carregar.navegacao.proximaPagina}">Iniciar Unidade</a>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			objetivoID.forEach(item => {
				$("#capaUnidade .objetivo h4").after(`<p>${contObjetivo[item]}</p>`);
			});
			if(contPrincipal.tituloUnidade){
				$("#tituloPagina h5").html(contPrincipal.tituloUnidade);
			}
		},
		progresso: function () {
			let menuLateral, y, w, completo;
			//Monta a barra de progresso baseada na quantidade de menus
			$("#paginaConteudo").append(
				`<div class="row mt-md">
					<div class="col-md-12">
						<div class="panel panel-default progresso">
							<div class="panel-body">
								<div class="progress">
									<div class="progress-bar" aria-valuenow="2" aria-valuemin="0" aria-valuemax="100" style="width: 5%;">0%</div>
								</div>
							</div>
						</div>
					</div>
				</div>`
			);
			$.getJSON("assets/json/navegacaoPrincipal.json", function (json) {
				menuLateral = json.menuLateral;
				for (y in menuLateral) {
					if(y !== "menu00"){
						completo = false;
						if ($(".menuPrincipal .menu-link."+ y +" > a").hasClass("completo")) {
							completo = true;
						}
						$(".progresso .panel-body").append(
							`${menuLateral[y].titulo !== undefined ? `<h2 class="mb-md${completo ? " completo" : ""}">${menuLateral[y].titulo}</h2>` : ""}`
						);
						for (w in menuLateral[y]) {
							if (w.startsWith("link")) {
								completo = false;
								if (menuLateral[y].titulo !== undefined) {
									if ($(".menuPrincipal .menu-link."+ y + " ul li a."+ w).hasClass("completo")) {
										completo = true;
									}
									$(".progresso .panel-body").append(
										`<div class="col-xs-12">
											<div class="well well-offset-1${completo ? " completo" : " incompleto"}">
												${menuLateral[y][w].texto}
												${completo ? `<i class="uil uil-check-circle"></i>` : ""}
											</div>
										</div>`
									);
								} else {
									if ($(".menuPrincipal .menu-link."+ y).children("a").hasClass("completo")) {
										completo = true;
									}
									$(".progresso .panel-body").append(
										`<div class="col-xs-12">
											<div class="well well-lg${completo ? " completo" : " incompleto"}">
												${menuLateral[y][w].texto}
												${completo ? `<i class="uil uil-check-circle"></i>` : ""}
											</div>
										</div>`
									);
								}
							}
						}
					}
				}
			});
		},
		dragnDrop: function(){
			//Componente para criação de atividades que possuem dragn'drop utilizando biblioteca hqy.interact.min.js
			criarDragndrop(carregar[x]);
		},
		conteudoExtra: function(tag, cpnt){
			let local, id, objeto, localAdd, nomeComponente;
			if (cpnt) {
				local = "#"+ tag +" .modal-body";
				id = cpnt;
				objeto = carregar[cpnt];
				localAdd = local +" ."+ id;
			}
			$(local).append(`<div data-componente="${id}" class="${id} mt-md"></div>`);
			for (let y in objeto) {
				nomeComponente = y.split(/[0-9]/)[0];//Regex para excluir números
				if (nomeComponente && this[nomeComponente] instanceof Function) {
					this[nomeComponente](localAdd, y, objeto[y]);
				} else {
					console.warn(`O componente "${nomeComponente}" enviado não é um componente válido para o ComponentMaker.`);
				}
			}
		},
		navegacao: function () {
			let objeto = carregar[x];
			//Adiciona links da navegação
			$("[data-navegacao='prevPage']").attr("href", "index.html#"+ objeto.paginaAnterior).show();
			$("[data-navegacao='nextPage']").attr("href", "index.html#"+ objeto.proximaPagina).show();
			//Oculta links de navegação vazios ou ausentes
			if(!objeto.paginaAnterior){ $("[data-navegacao='prevPage']").hide(); }
			if(!objeto.proximaPagina){ $("[data-navegacao='nextPage']").hide(); }
		}
	};
}